﻿#define DEMO

using System;
using System.Collections.Generic;

namespace ComplexConverter
{
    public class ComplexConverter
    {
        public event EventHandler<EventArg> Convert = delegate { };

#if DEMO
        // Dieser Separator kann Fehler verursachen, wenn Text gespeichert wird, der '|' enthält
        // Wird hier nur für die Demo verwendet
        private const char Separator = '|';
#else
        // Dieser Separator ist sicher, aber nicht darstellbar in der Richtextbox
        private const char Separator = System.Convert.ToChar(0xF019);
#endif
        internal void OnConvert(EventArg e)
        {
            this.Convert(this, e);
        }

        public string CreateDataString()
        {
            List<string> strings = new List<string>();
            this.Convert(this, new EventArg(strings, true));
            return string.Join(Separator.ToString(), strings.ToArray());
        }

        public void ApplyDataString(string s)
        {
            if (string.IsNullOrEmpty(s))
            {
                return;
            }

            List<string> backup = new List<string>();
            this.OnConvert(new EventArg(backup, true));
            try
            {
                // Restaurierung anhand von S versuchen
                this.OnConvert(new EventArg(s.Split(Separator), false));
            }
            catch (RestoreException)
            {
                // Im Fehlerfall Re-Restaurierung anhand des Backups
                this.OnConvert(new EventArg(backup, false));
            }
        }
    }
}
